Index: kernel/generic/include/debug/types.h
===================================================================
--- kernel/generic/include/debug/types.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ kernel/generic/include/debug/types.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,61 @@
+/*
+ * Copyright (c) 2023 Jiří Zárevúcky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef DEBUG_DWARF_TYPES_H_
+#define DEBUG_DWARF_TYPES_H_
+
+typedef unsigned dw_access_t;
+typedef unsigned dw_at_t;
+typedef unsigned dw_ate_t;
+typedef unsigned dw_cc_t;
+typedef unsigned dw_cfa_t;
+typedef unsigned dw_defaulted_t;
+typedef unsigned dw_ds_t;
+typedef unsigned dw_dsc_t;
+typedef unsigned dw_end_t;
+typedef unsigned dw_form_t;
+typedef unsigned dw_id_t;
+typedef unsigned dw_idx_t;
+typedef unsigned dw_idx_t;
+typedef unsigned dw_inl_t;
+typedef unsigned dw_lang_t;
+typedef unsigned dw_lle_t;
+typedef unsigned dw_lnct_t;
+typedef unsigned dw_lne_t;
+typedef unsigned dw_lns_t;
+typedef unsigned dw_macro_t;
+typedef unsigned dw_op_t;
+typedef unsigned dw_ord_t;
+typedef unsigned dw_rle_t;
+typedef unsigned dw_sect_t;
+typedef unsigned dw_tag_t;
+typedef unsigned dw_ut_t;
+typedef unsigned dw_virtuality_t;
+typedef unsigned dw_vis_t;
+
+#endif /* DEBUG_DWARF_TYPES_H_ */
Index: kernel/generic/include/lib/refcount.h
===================================================================
--- kernel/generic/include/lib/refcount.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/lib/refcount.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -49,7 +49,11 @@
 } atomic_refcount_t;
 
+#define REFCOUNT_INITIALIZER() { \
+	.__cnt = ATOMIC_VAR_INIT(0), \
+}
+
 static inline void refcount_init(atomic_refcount_t *rc)
 {
-	atomic_store_explicit(&rc->__cnt, 0, memory_order_relaxed);
+	atomic_init(&rc->__cnt, 0);
 }
 
@@ -74,4 +78,24 @@
 	assert(old >= 0);
 	(void) old;
+}
+
+/**
+ * Try to upgrade a weak reference.
+ * Naturally, this is contingent on another form of synchronization being used
+ * to ensure that the object continues to exist while the weak reference is in
+ * use.
+ */
+static inline bool refcount_try_up(atomic_refcount_t *rc)
+{
+	int cnt = atomic_load_explicit(&rc->__cnt, memory_order_relaxed);
+
+	while (cnt >= 0) {
+		if (atomic_compare_exchange_weak_explicit(&rc->__cnt, &cnt, cnt + 1,
+		    memory_order_relaxed, memory_order_relaxed)) {
+			return true;
+		}
+	}
+
+	return false;
 }
 
Index: kernel/generic/include/main/main.h
===================================================================
--- kernel/generic/include/main/main.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/main/main.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -43,6 +43,4 @@
 extern uint8_t kdata_end[];
 
-extern uintptr_t stack_safe;
-
 extern void main_bsp(void);
 extern void main_ap(void);
Index: kernel/generic/include/memw.h
===================================================================
--- kernel/generic/include/memw.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ kernel/generic/include/memw.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,51 @@
+/*
+ * Copyright (c) 2001-2004 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup kernel_generic
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_MEM_H_
+#define KERN_MEM_H_
+
+#include <stddef.h>
+#include <stdint.h>
+
+#include <mem.h>
+
+extern void memsetb(void *, size_t, uint8_t)
+    __attribute__((nonnull(1)));
+extern void memsetw(void *, size_t, uint16_t)
+    __attribute__((nonnull(1)));
+
+#endif
+
+/** @}
+ */
Index: kernel/generic/include/mm/as.h
===================================================================
--- kernel/generic/include/mm/as.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/mm/as.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -307,5 +307,5 @@
 extern as_t *AS_KERNEL;
 
-extern as_operations_t *as_operations;
+extern const as_operations_t *as_operations;
 extern list_t inactive_as_with_asid_list;
 
Index: kernel/generic/include/mm/mm.h
===================================================================
--- kernel/generic/include/mm/mm.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/mm/mm.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -46,4 +46,5 @@
 #define PAGE_EXEC_SHIFT			5
 #define PAGE_GLOBAL_SHIFT		6
+#define PAGE_WRITE_COMBINE_SHIFT  7
 
 #define PAGE_NOT_CACHEABLE		(0 << PAGE_CACHEABLE_SHIFT)
@@ -62,4 +63,6 @@
 #define PAGE_GLOBAL			(1 << PAGE_GLOBAL_SHIFT)
 
+#define PAGE_WRITE_COMBINE  (1 << PAGE_WRITE_COMBINE_SHIFT)
+
 #endif
 
Index: kernel/generic/include/mm/page.h
===================================================================
--- kernel/generic/include/mm/page.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/mm/page.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -53,5 +53,5 @@
 } page_mapping_operations_t;
 
-extern page_mapping_operations_t *page_mapping_operations;
+extern const page_mapping_operations_t *page_mapping_operations;
 
 extern void page_init(void);
Index: kernel/generic/include/mm/tlb.h
===================================================================
--- kernel/generic/include/mm/tlb.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/mm/tlb.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -36,4 +36,5 @@
 #define KERN_TLB_H_
 
+#include <arch/asm.h>
 #include <arch/mm/asid.h>
 #include <typedefs.h>
Index: kernel/generic/include/proc/program.h
===================================================================
--- kernel/generic/include/proc/program.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/proc/program.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -56,5 +56,5 @@
 
 extern errno_t program_create(as_t *, uspace_addr_t, char *, program_t *);
-extern errno_t program_create_from_image(void *, char *, program_t *);
+extern errno_t program_create_from_image(void *, size_t, char *, program_t *);
 extern errno_t program_create_loader(program_t *, char *);
 extern void program_ready(program_t *);
Index: kernel/generic/include/proc/scheduler.h
===================================================================
--- kernel/generic/include/proc/scheduler.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/proc/scheduler.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -41,4 +41,5 @@
 #include <atomic.h>
 #include <adt/list.h>
+#include <abi/proc/thread.h>
 
 #define RQ_COUNT          16
@@ -56,8 +57,12 @@
 
 extern void scheduler_fpu_lazy_request(void);
-extern void scheduler(void);
 extern void kcpulb(void *arg);
 
 extern void sched_print_list(void);
+
+extern void scheduler_run(void) __attribute__((noreturn));
+extern void scheduler_enter(state_t);
+
+extern void thread_main_func(void);
 
 /*
Index: kernel/generic/include/proc/task.h
===================================================================
--- kernel/generic/include/proc/task.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/proc/task.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -36,26 +36,27 @@
 #define KERN_TASK_H_
 
-#include <cpu.h>
-#include <ipc/ipc.h>
-#include <ipc/event.h>
-#include <ipc/kbox.h>
-#include <synch/spinlock.h>
-#include <synch/mutex.h>
+#include <abi/proc/task.h>
+#include <abi/sysinfo.h>
 #include <adt/list.h>
 #include <adt/odict.h>
-#include <security/perm.h>
+#include <arch/context.h>
+#include <arch/cpu.h>
+#include <arch/fpu_context.h>
 #include <arch/proc/task.h>
 #include <arch/proc/thread.h>
-#include <arch/context.h>
-#include <arch/fpu_context.h>
-#include <arch/cpu.h>
+#include <arch.h>
+#include <cap/cap.h>
+#include <cpu.h>
+#include <debug/sections.h>
+#include <ipc/event.h>
+#include <ipc/ipc.h>
+#include <ipc/kbox.h>
+#include <mm/as.h>
 #include <mm/tlb.h>
 #include <proc/scheduler.h>
+#include <security/perm.h>
+#include <synch/mutex.h>
+#include <synch/spinlock.h>
 #include <udebug/udebug.h>
-#include <mm/as.h>
-#include <abi/proc/task.h>
-#include <abi/sysinfo.h>
-#include <arch.h>
-#include <cap/cap.h>
 
 #define TASK                 CURRENT->task
@@ -87,6 +88,7 @@
 
 	/** Number of references (i.e. threads). */
-	atomic_size_t refcount;
+	atomic_refcount_t refcount;
 	/** Number of threads that haven't exited yet. */
+	// TODO: remove
 	atomic_size_t lifecount;
 
@@ -130,4 +132,6 @@
 	uint64_t ucycles;
 	uint64_t kcycles;
+
+	debug_sections_t *debug_sections;
 } task_t;
 
@@ -140,5 +144,4 @@
 extern void task_done(void);
 extern task_t *task_create(as_t *, const char *);
-extern void task_destroy(task_t *);
 extern void task_hold(task_t *);
 extern void task_release(task_t *);
Index: kernel/generic/include/proc/thread.h
===================================================================
--- kernel/generic/include/proc/thread.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/proc/thread.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -70,4 +70,6 @@
 /** Thread structure. There is one per thread. */
 typedef struct thread {
+	atomic_refcount_t refcount;
+
 	link_t rq_link;  /**< Run queue link. */
 	link_t wq_link;  /**< Wait queue link. */
@@ -77,11 +79,48 @@
 	odlink_t lthreads;
 
-	/** Lock protecting thread structure.
+	/** Tracking variable for thread_wait/thread_wakeup */
+	atomic_int sleep_state;
+
+	/**
+	 * If true, the thread is terminating.
+	 * It will not go to sleep in interruptible synchronization functions
+	 * and will call thread_exit() before returning to userspace.
+	 */
+	volatile bool interrupted;
+
+	/** Wait queue in which this thread sleeps. Used for debug printouts. */
+	_Atomic(waitq_t *) sleep_queue;
+
+	/** Waitq for thread_join_timeout(). */
+	waitq_t join_wq;
+
+	/** Thread accounting. */
+	atomic_time_stat_t ucycles;
+	atomic_time_stat_t kcycles;
+
+	/** Architecture-specific data. */
+	thread_arch_t arch;
+
+#ifdef CONFIG_UDEBUG
+	/**
+	 * If true, the scheduler will print a stack trace
+	 * to the kernel console upon scheduling this thread.
+	 */
+	atomic_int_fast8_t btrace;
+
+	/** Debugging stuff */
+	udebug_thread_t udebug;
+#endif /* CONFIG_UDEBUG */
+
+	/*
+	 * Immutable fields.
 	 *
-	 * Protects the whole thread structure except list links above.
-	 */
-	IRQ_SPINLOCK_DECLARE(lock);
-
-	char name[THREAD_NAME_BUFLEN];
+	 * These fields are only modified during initialization, and are not
+	 * changed at any time between initialization and destruction.
+	 * Can be accessed without synchronization in most places.
+	 */
+
+	/** Thread ID. */
+	thread_id_t tid;
 
 	/** Function implementing the thread. */
@@ -90,4 +129,32 @@
 	void *thread_arg;
 
+	char name[THREAD_NAME_BUFLEN];
+
+	/** Thread is executed in user space. */
+	bool uspace;
+
+	/** Thread doesn't affect accumulated accounting. */
+	bool uncounted;
+
+	/** Containing task. */
+	task_t *task;
+
+	/** Thread's kernel stack. */
+	uint8_t *kstack;
+
+	/*
+	 * Local fields.
+	 *
+	 * These fields can be safely accessed from code that _controls execution_
+	 * of this thread. Code controls execution of a thread if either:
+	 *  - it runs in the context of said thread AND interrupts are disabled
+	 *    (interrupts can and will access these fields)
+	 *  - the thread is not running, and the code accessing it can legally
+	 *    add/remove the thread to/from a runqueue, i.e., either:
+	 *    - it is allowed to enqueue thread in a new runqueue
+	 *    - it holds the lock to the runqueue containing the thread
+	 *
+	 */
+
 	/**
 	 * From here, the stored context is restored
@@ -96,32 +163,5 @@
 	context_t saved_context;
 
-	/**
-	 * From here, the stored timeout context
-	 * is restored when sleep times out.
-	 */
-	context_t sleep_timeout_context;
-
-	/**
-	 * From here, the stored interruption context
-	 * is restored when sleep is interrupted.
-	 */
-	context_t sleep_interruption_context;
-
-	/** If true, the thread can be interrupted from sleep. */
-	bool sleep_interruptible;
-
-	/**
-	 * If true, and this thread's sleep returns without a wakeup
-	 * (timed out or interrupted), waitq ignores the next wakeup.
-	 * This is necessary for futex to be able to handle those conditions.
-	 */
-	bool sleep_composable;
-
-	/** Wait queue in which this thread sleeps. */
-	waitq_t *sleep_queue;
-	/** Timeout used for timeoutable sleeping.  */
-	timeout_t sleep_timeout;
-	/** Flag signalling sleep timeout in progress. */
-	volatile bool timeout_pending;
+	// TODO: we only need one of the two bools below
 
 	/**
@@ -137,76 +177,35 @@
 	bool in_copy_to_uspace;
 
-	/**
-	 * If true, the thread will not go to sleep at all and will call
-	 * thread_exit() before returning to userspace.
-	 */
-	bool interrupted;
-
-	/** If true, thread_join_timeout() cannot be used on this thread. */
-	bool detached;
-	/** Waitq for thread_join_timeout(). */
-	waitq_t join_wq;
-	/** Link used in the joiner_head list. */
-	link_t joiner_link;
-
-	fpu_context_t *saved_fpu_context;
+	/*
+	 * FPU context is a special case. If lazy FPU switching is disabled,
+	 * it acts as a regular local field. However, if lazy switching is enabled,
+	 * the context is synchronized via CPU->fpu_lock
+	 */
+#ifdef CONFIG_FPU
+	fpu_context_t fpu_context;
+#endif
 	bool fpu_context_exists;
-
-	/*
-	 * Defined only if thread doesn't run.
-	 * It means that fpu context is in CPU that last time executes this
-	 * thread. This disables migration.
-	 */
-	bool fpu_context_engaged;
 
 	/* The thread will not be migrated if nomigrate is non-zero. */
 	unsigned int nomigrate;
 
-	/** Thread state. */
-	state_t state;
-
-	/** Thread CPU. */
-	cpu_t *cpu;
-	/** Containing task. */
-	task_t *task;
-	/** Thread is wired to CPU. */
-	bool wired;
 	/** Thread was migrated to another CPU and has not run yet. */
 	bool stolen;
-	/** Thread is executed in user space. */
-	bool uspace;
-
-	/** Ticks before preemption. */
-	uint64_t ticks;
-
-	/** Thread accounting. */
-	uint64_t ucycles;
-	uint64_t kcycles;
+
+	/**
+	 * Thread state (state_t).
+	 * This is atomic because we read it via some commands for debug output,
+	 * otherwise it could just be a regular local.
+	 */
+	atomic_int_fast32_t state;
+
+	/** Thread CPU. */
+	_Atomic(cpu_t *) cpu;
+
+	/** Thread's priority. Implemented as index to CPU->rq */
+	atomic_int_fast32_t priority;
+
 	/** Last sampled cycle. */
 	uint64_t last_cycle;
-	/** Thread doesn't affect accumulated accounting. */
-	bool uncounted;
-
-	/** Thread's priority. Implemented as index to CPU->rq */
-	int priority;
-	/** Thread ID. */
-	thread_id_t tid;
-
-	/** Architecture-specific data. */
-	thread_arch_t arch;
-
-	/** Thread's kernel stack. */
-	uint8_t *kstack;
-
-#ifdef CONFIG_UDEBUG
-	/**
-	 * If true, the scheduler will print a stack trace
-	 * to the kernel console upon scheduling this thread.
-	 */
-	bool btrace;
-
-	/** Debugging stuff */
-	udebug_thread_t udebug;
-#endif /* CONFIG_UDEBUG */
 } thread_t;
 
@@ -219,8 +218,44 @@
 extern void thread_wire(thread_t *, cpu_t *);
 extern void thread_attach(thread_t *, task_t *);
-extern void thread_ready(thread_t *);
+extern void thread_start(thread_t *);
+extern void thread_requeue_sleeping(thread_t *);
 extern void thread_exit(void) __attribute__((noreturn));
 extern void thread_interrupt(thread_t *);
-extern bool thread_interrupted(thread_t *);
+
+enum sleep_state {
+	SLEEP_INITIAL,
+	SLEEP_ASLEEP,
+	SLEEP_WOKE,
+};
+
+typedef enum {
+	THREAD_OK,
+	THREAD_TERMINATING,
+} thread_termination_state_t;
+
+typedef enum {
+	THREAD_WAIT_SUCCESS,
+	THREAD_WAIT_TIMEOUT,
+} thread_wait_result_t;
+
+extern thread_termination_state_t thread_wait_start(void);
+extern thread_wait_result_t thread_wait_finish(deadline_t);
+extern void thread_wakeup(thread_t *);
+
+static inline thread_t *thread_ref(thread_t *thread)
+{
+	refcount_up(&thread->refcount);
+	return thread;
+}
+
+static inline thread_t *thread_try_ref(thread_t *thread)
+{
+	if (refcount_try_up(&thread->refcount))
+		return thread;
+	else
+		return NULL;
+}
+
+extern void thread_put(thread_t *);
 
 #ifndef thread_create_arch
@@ -239,12 +274,11 @@
 extern void thread_usleep(uint32_t);
 
-#define thread_join(t) \
-	thread_join_timeout((t), SYNCH_NO_TIMEOUT, SYNCH_FLAGS_NONE)
-
+extern errno_t thread_join(thread_t *);
 extern errno_t thread_join_timeout(thread_t *, uint32_t, unsigned int);
 extern void thread_detach(thread_t *);
 
+extern void thread_yield(void);
+
 extern void thread_print_list(bool);
-extern void thread_destroy(thread_t *, bool);
 extern thread_t *thread_find_by_id(thread_id_t);
 extern size_t thread_count(void);
@@ -252,5 +286,5 @@
 extern thread_t *thread_next(thread_t *);
 extern void thread_update_accounting(bool);
-extern bool thread_exists(thread_t *);
+extern thread_t *thread_try_get(thread_t *);
 
 extern void thread_migration_disable(void);
Index: kernel/generic/include/smp/smp.h
===================================================================
--- kernel/generic/include/smp/smp.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/smp/smp.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -36,7 +36,7 @@
 #define KERN_SMP_H_
 
-#include <synch/waitq.h>
+#include <synch/semaphore.h>
 
-extern waitq_t ap_completion_wq;
+extern semaphore_t ap_completion_semaphore;
 
 #ifdef CONFIG_SMP
Index: kernel/generic/include/stacktrace.h
===================================================================
--- kernel/generic/include/stacktrace.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/stacktrace.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -52,5 +52,5 @@
 	bool (*frame_pointer_prev)(stack_trace_context_t *, uintptr_t *);
 	bool (*return_address_get)(stack_trace_context_t *, uintptr_t *);
-	bool (*symbol_resolve)(uintptr_t, const char **, uintptr_t *);
+	bool (*symbol_resolve)(uintptr_t, int, const char **, uintptr_t *, const char **, const char **, int *, int *);
 } stack_trace_ops_t;
 
Index: kernel/generic/include/symtab.h
===================================================================
--- kernel/generic/include/symtab.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/symtab.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -36,9 +36,13 @@
 #define KERN_SYMTAB_H_
 
-#include <symtab_lookup.h>
-#include <console/chardev.h>
+#include <stdbool.h>
+#include <typedefs.h>
+#include <debug/sections.h>
 
 extern void symtab_print_search(const char *);
 extern const char *symtab_hints_enum(const char *, const char **, void **);
+extern const char *symtab_fmt_name_lookup(uintptr_t);
+extern errno_t symtab_addr_lookup(const char *, uintptr_t *);
+extern const char *symtab_name_lookup(uintptr_t, uintptr_t *, debug_sections_t *);
 
 #endif
Index: kernel/generic/include/synch/condvar.h
===================================================================
--- kernel/generic/include/synch/condvar.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/synch/condvar.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -46,9 +46,4 @@
 } condvar_t;
 
-#define condvar_wait(cv, mtx) \
-	_condvar_wait_timeout((cv), (mtx), SYNCH_NO_TIMEOUT, SYNCH_FLAGS_NONE)
-#define condvar_wait_timeout(cv, mtx, usec) \
-	_condvar_wait_timeout((cv), (mtx), (usec), SYNCH_FLAGS_NONE)
-
 #ifdef CONFIG_SMP
 #define _condvar_wait_timeout_spinlock(cv, lock, usec, flags) \
@@ -62,6 +57,8 @@
 extern void condvar_signal(condvar_t *cv);
 extern void condvar_broadcast(condvar_t *cv);
-extern errno_t _condvar_wait_timeout(condvar_t *cv, mutex_t *mtx, uint32_t usec,
-    int flags);
+
+extern errno_t condvar_wait(condvar_t *cv, mutex_t *mtx);
+extern errno_t condvar_wait_timeout(condvar_t *cv, mutex_t *mtx, uint32_t usec);
+
 extern errno_t _condvar_wait_timeout_spinlock_impl(condvar_t *cv, spinlock_t *lock,
     uint32_t usec, int flags);
Index: kernel/generic/include/synch/mutex.h
===================================================================
--- kernel/generic/include/synch/mutex.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/synch/mutex.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -56,16 +56,9 @@
 } mutex_t;
 
-#define mutex_lock(mtx) \
-	_mutex_lock_timeout((mtx), SYNCH_NO_TIMEOUT, SYNCH_FLAGS_NONE)
-
-#define mutex_trylock(mtx) \
-	_mutex_lock_timeout((mtx), SYNCH_NO_TIMEOUT, SYNCH_FLAGS_NON_BLOCKING)
-
-#define mutex_lock_timeout(mtx, usec) \
-	_mutex_lock_timeout((mtx), (usec), SYNCH_FLAGS_NON_BLOCKING)
-
 extern void mutex_initialize(mutex_t *, mutex_type_t);
 extern bool mutex_locked(mutex_t *);
-extern errno_t _mutex_lock_timeout(mutex_t *, uint32_t, unsigned int);
+extern errno_t mutex_trylock(mutex_t *);
+extern void mutex_lock(mutex_t *);
+extern errno_t mutex_lock_timeout(mutex_t *, uint32_t);
 extern void mutex_unlock(mutex_t *);
 
Index: kernel/generic/include/synch/semaphore.h
===================================================================
--- kernel/generic/include/synch/semaphore.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/synch/semaphore.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -45,21 +45,9 @@
 } semaphore_t;
 
-#define semaphore_down(s) \
-	_semaphore_down_timeout((s), SYNCH_NO_TIMEOUT, SYNCH_FLAGS_NONE)
-
-#define semaphore_trydown(s) \
-	_semaphore_down_timeout((s), SYNCH_NO_TIMEOUT, SYNCH_FLAGS_NON_BLOCKING)
-
-#define semaphore_down_timeout(s, usec) \
-	_semaphore_down_timeout((s), (usec), SYNCH_FLAGS_NONE)
-
-#define semaphore_down_interruptable(s) \
-	(_semaphore_down_timeout((s), SYNCH_NO_TIMEOUT, \
-		SYNCH_FLAGS_INTERRUPTIBLE) != EINTR)
-
 extern void semaphore_initialize(semaphore_t *, int);
-extern errno_t _semaphore_down_timeout(semaphore_t *, uint32_t, unsigned int);
+extern errno_t semaphore_down_timeout(semaphore_t *, uint32_t);
+extern errno_t semaphore_trydown(semaphore_t *);
+extern void semaphore_down(semaphore_t *);
 extern void semaphore_up(semaphore_t *);
-extern int semaphore_count_get(semaphore_t *);
 
 #endif
